/*
** $Id: tor_sum_vi32_i32.S,v 1.1 1995/09/08 22:46:16 davidj Exp $
**
** davidj - Tue Feb  7 19:49:27 1995
*/

#include "tor/tordef.h"

#ifdef DECL_tor_sum_vi32_i32
intv_int32_t tor_sum_vi32_i32(size_t len, const intv_int32_t* in);
#endif

#ifdef DEFN_tor_sum_vi32_i32

	.globl	tor_sum_vi32_i32


#define	in_v		vv1
#define sum_v		vv2
#define	tmp_v		vv3

#define len_r		a0
#define inptr_r		a1

#define maxvlen_r	t0
#define redvlr_r	t1
#define done_r		t2
#define fourvlr_r	t3
#define shortred_r	t4	/* Set to 1 if <= 16 elements */


	.ent	tor_sum_vi32_i32
tor_sum_vi32_i32:
	li	maxvlen_r, MAXVLEN
	.set	noreorder
        bgtu    len_r, MAXVLEN, morethanvlen
        ctvu    maxvlen_r, vlr
	.set	reorder

 # The short case (len<=32) follows directly for better cache performance

	mov.vs	sum_v, zero
	ctvu	len_r, vlr
        lw.v	sum_v, inptr_r
	# Work out if reducing <= 16 elements
 	sltu	shortred_r, len_r, MAXVLEN/2+1
	li	redvlr_r, MAXVLEN/2
	# Divide vlr by 2 if <= 16 elements to reduce
 	srl	redvlr_r, shortred_r

reduce:
	ctvu	redvlr_r, vlr
redloop:
	vext.v	tmp_v, sum_v, redvlr_r
	srl	redvlr_r, 1
	addu.vv	sum_v, tmp_v
	ctvu	redvlr_r, vlr
	bnez	redvlr_r, redloop

	vext.s	v0, sum_v, zero
	# Fuctions return 32 bit result in v0
	j	ra

morethanvlen:
	lw.v	in_v, inptr_r
	mov.vs	sum_v, zero
	li	fourvlr_r, MAXVLEN*4
	addu	inptr_r, fourvlr_r

loop:
	addu.vv	sum_v, in_v	
	lwai.v	in_v, inptr_r, fourvlr_r
	subu	len_r, MAXVLEN
	sltu	done_r, len_r, MAXVLEN+1
	beqz	done_r, loop

	ctvu	len_r, vlr
	addu.vv	sum_v, in_v
	li	redvlr_r, MAXVLEN/2
	

 # Go back to reduction above to finish

	b	reduce

	.end	tor_sum_vi32_i32

#endif
